--[[

]]--
local addonName, vars = ...
local L = vars.L --- localizzazione
local ERA = _G[addonName]

--Upvalue
local format, UnitClass, UnitExists, IsInGroup, GetNumGroupMembers, UnitGroupRolesAssigned = string.format, UnitClass, UnitExists, IsInGroup, GetNumGroupMembers, UnitGroupRolesAssigned

function ERA:ClassColoredName(unit)
   local _,class = UnitClass(unit)
   local color = RAID_CLASS_COLORS[class]
   return(format("\|c%s%s\|r", color.colorStr,GetUnitName(unit)))
end

function ERA:TargetingList(what, inverse)
   --what puo' essere focus o target. altri valori sono errori di codice
   if not what or (what ~= "focus" and what ~= "target") then return format("\|cFFFF0000 Error what = %s\n\|r",what or "nil")  end
   --se non c'è trget o focus lo diciamo
   if not UnitExists(what) then return format("\|cFFFF0000No %s\|r\n",what)  end
	local where = ERA:IsGrouped()
   --se non siamo in gruppo il frame non serve
   if not where then 
      return L["\|cFFFF0000Not in group\|r\n"]
   end   
   local list = ""
   local m,n,dps,dead,role,who = GetNumGroupMembers(),0,0,0
   for i = 1, m do
      who = where..i
      if where == "party" and i == m then who = "player"end
      role = UnitGroupRolesAssigned(who)         
      if role ~= "TANK" and role ~= "HEALER" then
         if not UnitIsDead(who) then
            dps = dps+1
            if (not inverse and UnitIsUnit(what,who.."target")) or (inverse and not UnitIsUnit(what,who.."target")) then
               n = n + 1
               list = format("%s%s\n", list, ERA:ClassColoredName(who))
            end
         else
            dead = dead+1
         end
      end      
   end

   --quanti dps targettano il bersaglio
   local count = format("%s\/%s DPS", n, dps)
   count = inverse and format("\|cFFFF0000%s|r", count) or count
   --quanti morti
   local rip = ""--format(" -%s \|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_8:0\|t",dead)
   --   il report definitivo
   list = format("%s%s\n%s",count, dead > 0 and rip or "", n > 0  and list or L["\|cFFFF0000NO ONE\|r\n"])
   return list
end

function ERA:DpsCountOn(what)
   if not ERA[what] then return end      
   ERA[what].txt:SetText(ERA:TargetingList(what, ERA:AssistMonitorListOrder(what)))
end

function ERA:CreateAssistMonitor(what)
   if not ERA[what] then
      ERA[what] = ERA:Frame(ERA.monitorClass,what)
      ERA[what].title.txt:SetText(ERA:Upper1(what))
      ERA:EnableFrameDB(ERA[what])
      ERA:SetFrameVal(ERA[what],"counter", 0)
      ERA:SetFrameVal(ERA[what], "lock", ERA:GetFrameDB(ERA[what],"lock"))
      ERA[what]:SetScript("OnUpdate", function(self, elapsed)           
            ERA:SetFrameVal(self, "counter", ERA:GetFrameVal(self, "counter") + elapsed)
            if ERA:GetFrameVal(self, "counter") > ERA.delay then
               ERA:SetFrameVal(self, "counter", 0)
               ERA:DpsCountOn(ERA:GetFrameVal(self,"type"))
            end
      end) 
      ERA:LockUnlockFrame(ERA[what], ERA:GetFrameDB(ERA[what],"lock"))
      ERA:RestoreFramePos(ERA[what])
   end      
end

function ERA:ShowAssistMonitor(what)
	if what and (what == "focus" or what == "target") then
		if not ERA[what] then ERA:CreateAssistMonitor(what) end
		ERA[what]:Show()
	end
end

local function GetAssistMonitorDB()
	return ERA:DB()["assistMonitor"]
end

function ERA:AssistMonitorListOrder(what)
	return GetAssistMonitorDB()[what].inverti
end

function ERA:HideAssistMonitor(what)
	if what and (what == "focus" or what == "target") and ERA[what] then    
		ERA[what]:Hide()
	end
end

function ERA:IsMonitorEnabled(what)
	if what then    
		return GetAssistMonitorDB()[what].attiva
	end
end

function ERA:IsMonitorRaidOnly(what)
	if what then    
		return GetAssistMonitorDB()[what].raidOnly
	end
end

function ERA:IsMonitornotLFR(what)
	if what then    
		return GetAssistMonitorDB()[what].notInLFR
	end
end

function ERA:IsMonitorTest(what)
	if what and (what == "focus" or what == "target") then    
		return ERA["_"..what.."MonitorTest"]
	end
end

function ERA:CanMonitorBeShown(what)
	if ERA:IsMonitorEnabled(what) and (
		(IsInGroup() or IsInRaid())
		and (not ERA:IsMonitorRaidOnly(what) or IsInRaid())
		and (not ERA:IsMonitornotLFR(what) or (select(3, GetInstanceInfo())) ~= 17)
	)
	then return true
	end
end